Exiv2: Exiv2::ValueType< T > Class Template Reference

# Exiv2::ValueType< T > Class Template Reference

Template for a Value of a basic type. This is used for unsigned and signed short, long and rationals. More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::ValueType< T >:
[legend]
Collaboration diagram for Exiv2::ValueType< T >:
[legend]

List of all members.

## Public Types
typedef std::auto_ptr < ValueType< T > > | AutoPtr
| Shortcut for a ValueType<T> auto pointer.
typedef std::vector< T > | ValueList
| Container for values.
typedef std::vector< T >::iterator | iterator
| Iterator type defined for convenience.
typedef std::vector< T > ::const_iterator | const_iterator
| Const iterator type defined for convenience.
## Public Member Functions
template<>
long | toLong (long n) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
template<>
long | toLong (long n) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
template<>
float | toFloat (long n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
template<>
float | toFloat (long n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
template<>
Rational | toRational (long n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
template<>
Rational | toRational (long n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
Creators
| ValueType ()
| Default constructor.
| ValueType (const byte *buf, long len, ByteOrder byteOrder)
| Constructor.
| ValueType (const T &val, ByteOrder byteOrder=littleEndian)
| Constructor.
| ValueType (const ValueType< T > &rhs)
| Copy constructor.
virtual | ~ValueType ()
| Virtual destructor.
Manipulators
ValueType< T > & | operator= (const ValueType< T > &rhs)
| Assignment operator.
virtual int | read (const byte *buf, long len, ByteOrder byteOrder)
| Read the value from a character buffer.
virtual int | read (const std::string &buf)
| Set the data from a string of values of type T (e.g., "0 1 2 3" or "1/2 1/3 1/4" depending on what T is). Generally, the accepted input format is the same as that produced by the write() method.
virtual int | setDataArea (const byte *buf, long len)
| Set the data area. This method copies (clones) the buffer pointed to by buf.
Accessors
AutoPtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
virtual long | copy (byte *buf, ByteOrder byteOrder) const
| Write value to a data buffer.
virtual long | count () const
| Return the number of components of the value.
virtual long | size () const
| Return the size of the value in bytes.
virtual std::ostream & | write (std::ostream &os) const
| Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).
virtual std::string | toString (long n) const
| Return the n-th component of the value as a string. The behaviour of this method may be undefined if there is no n-th component.
virtual long | toLong (long n=0) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
virtual float | toFloat (long n=0) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
virtual Rational | toRational (long n=0) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
virtual long | sizeDataArea () const
| Return the size of the data area.
virtual DataBuf | dataArea () const
| Return a copy of the data area in a DataBuf. The caller owns this copy and DataBuf ensures that it will be deleted.
## Public Attributes
ValueList | value_
| The container for all values. In your application, if you know what subclass of Value you're dealing with (and possibly the T) then you can access this STL container through the usual standard library functions.

## Detailed Description

### template<typename T>
class Exiv2::ValueType< T >

Template for a Value of a basic type. This is used for unsigned and signed short, long and rationals.

Examples:

  addmoddel.cpp.

## Member Function Documentation

template<typename T>

int Exiv2::ValueType< T >::read | ( | const byte * | buf,
|  | long | len,
|  | ByteOrder | byteOrder |
| ) |  |  | `[inline, virtual]`

Read the value from a character buffer.

Parameters:

  | buf | Pointer to the data buffer to read from
  | len | Number of bytes in the data buffer
  | byteOrder | Applicable byte order (little or big endian).

Returns:
  0 if successful.

Implements Exiv2::Value.

References Exiv2::Value::typeId(), Exiv2::TypeInfo::typeSize(), and Exiv2::ValueType< T >::value_.

Referenced by Exiv2::ValueType< T >::ValueType().

template<typename T>

long Exiv2::ValueType< T >::copy | ( | byte * | buf,
|  | ByteOrder | byteOrder |
| ) |  |  | const`[inline, virtual]`

Write value to a data buffer.

The user must ensure that the buffer has enough memory. Otherwise the call results in undefined behaviour.

Parameters:

  | buf | Data buffer to write to.
  | byteOrder | Applicable byte order (little or big endian).

Returns:
  Number of bytes written.

Implements Exiv2::Value.

References Exiv2::toData(), and Exiv2::ValueType< T >::value_.

template<typename T>

long Exiv2::ValueType< T >::toLong | ( | long | n = `0` | ) | const`[inline, virtual]`

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and Exiv2::ValueType< T >::value_.

template<typename T>

float Exiv2::ValueType< T >::toFloat | ( | long | n = `0` | ) | const`[inline, virtual]`

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and Exiv2::ValueType< T >::value_.

template<typename T>

Rational Exiv2::ValueType< T >::toRational | ( | long | n = `0` | ) | const`[inline, virtual]`

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and Exiv2::ValueType< T >::value_.

template<>

long Exiv2::ValueType< Rational >::toLong | ( | long | n | ) | const`[inline, virtual]`

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and Exiv2::ValueType< T >::value_.

template<>

long Exiv2::ValueType< URational >::toLong | ( | long | n | ) | const`[inline, virtual]`

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and Exiv2::ValueType< T >::value_.

template<>

float Exiv2::ValueType< Rational >::toFloat | ( | long | n | ) | const`[inline, virtual]`

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and Exiv2::ValueType< T >::value_.

template<>

float Exiv2::ValueType< URational >::toFloat | ( | long | n | ) | const`[inline, virtual]`

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and Exiv2::ValueType< T >::value_.

template<>

Rational Exiv2::ValueType< Rational >::toRational | ( | long | n | ) | const`[inline, virtual]`

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and Exiv2::ValueType< T >::value_.

template<>

Rational Exiv2::ValueType< URational >::toRational | ( | long | n | ) | const`[inline, virtual]`

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns:
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and Exiv2::ValueType< T >::value_.

The documentation for this class was generated from the following file:

- value.hpp